class Event < ActiveRecord::Base

  tkh_searchable
  def self.tkh_search_indexable_fields
    indexable_fields = {
      name: 8,
      description: 3,
      body: 2
    }
  end

  def to_param
    name ? "#{id}-#{name.to_url}" : id
  end

  scope :published, -> { where( published: true ) }
  scope :in_the_future, -> { where( 'starts_at >= ?', Time.zone.now.beginning_of_day ) }
  scope :chronologically, -> { order 'starts_at' }
  scope :by_recent, -> { order('updated_at desc') }

  def self.duplicate( source_event_id )
    old_event = find( source_event_id )
    new_event = old_event.dup
    new_event.name = "Copy of #{old_event.name}"
    new_event.save
  end

end
